#!/bin/bash

# Nyaaget (mappy 2013)
# Downloads torrents from nyaa and automatically adds them to transmission
#
# Usage: ./nyaaget "search terms"
#
# To run automatically every two hours:
# Run    crontab -e    to edit your user's crontab, and add a line like
# 0 */2 * * * /home/me/nyaaget/nyaaget.sh "Miya-k Miyakawa-ke no Kuufuku"


TORRENT_FILE_DIR=/home/.autonyaa/
NYAA_HOSTNAME=http://www.nyaa.se/

if [ "$#" -ne 1 ] ; then
	echo "Usage: $1 \"search terms\""
	exit 1
fi

if [ ! -d "${TORRENT_FILE_DIR}" ] ; then
	mkdir -p "${TORRENT_FILE_DIR}"
fi

dbgstr() {
	if [ ! -z $NYAAGET_DEBUG ]; then
		echo "$1"
	fi
}
dbgstr "In debug mode"

URLS=$(
	curl -s "${NYAA_HOSTNAME}?page=rss&term=`echo "$1" | sed 's/ /+/g'`" |\
	 grep -Eo "${NYAA_HOSTNAME}\?page=download[^<]*" |\
	 sed 's/#38;//'
)

for url in $URLS ; do
	TID=`echo "$url" | sed 's/.*tid=//'`
	if [ ! -f ${TORRENT_FILE_DIR}nyaa_$TID.torrent ]; then
		# Torrent file hasn't been downloaded before
		curl -s "$url" > ${TORRENT_FILE_DIR}nyaa_$TID.torrent

		transmission-remote -a "${TORRENT_FILE_DIR}nyaa_$TID.torrent" >/dev/null
	fi
done

exit 0
